<mat-grid-list cols="2" rowHeight="10:1">
  <mat-grid-tile>
    <h2>Catálogo Roles de Usuario</h2>
  </mat-grid-tile>
  <mat-grid-tile>
    <button mat-raised-button color="primary" (click)="openDialog(null)">
      <mat-icon>add</mat-icon>
      Nuevo Rol
    </button></mat-grid-tile>
</mat-grid-list>

<mat-divider></mat-divider>



<div class="schedule-table" >

  <div class="spinner-container" *ngIf="dataSource.loading$|async">
    <mat-spinner></mat-spinner>
  </div>

  <div *ngIf="dataSource.rolesData.value.length == 0">
   ALV
  </div> 

  
  <mat-form-field class="example-full-width">
    <input matInput type="search" placeholder="Buscar" value="" [formControl]="searchInput">
    <button mat-button *ngIf="searchInput.value" matSuffix mat-icon-button aria-label="Clear" (click)="searchInput.setValue('')">
      <mat-icon>close</mat-icon>
    </button>
  </mat-form-field>




  <mat-table 
    class="schedule-status-table mat-elevation-z8" 
    [dataSource]="dataSource" 
    matSort 
    matSortActive="name"
    matSortDirection="asc" 
    matSortDisableClear>


    <ng-container matColumnDef="code">
      <mat-header-cell *matHeaderCellDef mat-sort-header>Código</mat-header-cell>
      <mat-header-cell *matCellDef="let role">{{role.code}}</mat-header-cell>
    </ng-container>

    <ng-container matColumnDef="description">
      <mat-header-cell *matHeaderCellDef mat-sort-header>Descripción</mat-header-cell>
      <mat-header-cell *matCellDef="let role">{{role.description}}</mat-header-cell>
    </ng-container>


    <ng-container matColumnDef="created_at">
      <mat-header-cell *matHeaderCellDef>Fecha Creación</mat-header-cell>
      <mat-header-cell *matCellDef="let role">{{role.created_at}}</mat-header-cell>
    </ng-container>

    <ng-container matColumnDef="updated_at">
      <mat-header-cell *matHeaderCellDef>Última Actualización</mat-header-cell>
      <mat-header-cell *matCellDef="let role">{{role.updated_at}}</mat-header-cell>
    </ng-container>

    <ng-container matColumnDef="is_active">
      <mat-header-cell *matHeaderCellDef>Status</mat-header-cell>


      <mat-header-cell *matCellDef="let role">
        <mat-chip-list>
          <mat-chip color="primary" selected *ngIf="role.is_active">Activado</mat-chip>
          <mat-chip color="warn" selected *ngIf="!role.is_active">Desactivado</mat-chip>
        </mat-chip-list>

      </mat-header-cell>
    </ng-container>

    <ng-container matColumnDef="actions">
      <mat-header-cell *matHeaderCellDef>Acciones</mat-header-cell>
      <mat-header-cell *matCellDef="let role">
        <div class="button-row">
          <button mat-raised-button color="primary" (click)="openDialog(role)">
            <mat-icon>edit</mat-icon>
            Editar
          </button>

          <button mat-raised-button [color]="role.is_active?'warn':'primary'">
            <mat-icon>{{role.is_active ? 'cancel':'check'}}</mat-icon>
            {{role.is_active ? 'Desactivar' : 'Activar'}}
          </button>

        </div>
      </mat-header-cell>
    </ng-container>

    <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>

    <mat-row *matRowDef="let row; columns: displayedColumns"></mat-row>

  </mat-table>



  <mat-paginator [length]="dataSource.noPages$ |async " [pageSize]="10" [pageSizeOptions]="[10,20,30,50]">

  </mat-paginator>

</div>